//#define DEBUG

/* -------------------------------------------------
	Virtual Load

	CPU : ATmega168P-MMH <Atmel>

Function :
	׃hCu[h
		ECC_Mode
			d[hB
				ER}h
					c c (Current_mA)

		ECV_Mode
			d[hB
				ER}h
					c v (Voltage_mV)

		ECR_Mode
			R[hB
				ER}h
					c r (registance_m)

		ECP_Mode
			d̓[hB
				ER}h
					c p (Power_mW)

		EBattery Discharge Prot Mode
			obed胂[h
				ER}h
					b (I~d[mV]) (דd[mA]) (Ԋu[Sec])

		EPowersource IL-Vout Prot Mode
			dd胂[h
				ER}h
					p (I~d[mA]) (Ihbvd[mV]) (Ԋu[mA/Step])

		Edisable_Mode
			hCu~B
				ER}h
					c d

		ECurrent Limitter
			\tgd~bglݒ
				ER}h
					c L (d[mA])

	胂[h
		R}hs̒[qdEdEd͓o͂B
		ɂăqgǂ݂₷tH[}bg
		csvŃC|[g₷tH[}bgIB
				ER}h
					r[m]
					mFqgɗD\B
						V:xxxxx [mV]
						I:xxx [mA]
						P:xxxx [mW]
						R:xxxx [mohm]

					mLFcsvC|[gp\B
						set,V,I,0,0(,P,R)̏ŏo͂B(P,R͖A܂0\ƂB)
						xxxxx,xxxx,xxxxx,xxxxx\r

	Calibration_Mode
		dEdo͕̍Zs[hB
		EdZ
			@d[q̍ZsB
			w肳dAOɗpӂd苟
			eX^ől"mVPʂ"͂B

			ER}h
				x v
				Please supply Voltage. Recommend setting it oooo [mV] : xxxxx

		Eo͓dZ
			@dp[q̍ZsB
			3Aȏ̓ddpӂ邱ƁB
			R}hsAdqׂ̓bZ[Wŕ\dl
			o͂B eX^̓dv[hő肵
			̑l"mAPʂ"͂B
			5mA25mA50mA500mA1.5A3A
			L̏Ԃœdݒ肳BeX^̃Wɒӂ邱ƁB
			
			ER}h
				x i
				Please input Measure Current. Setting to %u [mA] : xxxx

		EZ폜
			ɐݒ肳ĂZSč폜B
			mF͂ȂB

			ER}h
				x c

	o[W
		t@[EFÃo[W\B
		ER}h
			v ()
			Virtual Load verx.x

		Device: atmega168p
		Program:   14310 bytes (87.3% Full)
		(.text + .data + .bootloader)
		Data:        379 bytes (37.0% Full)
		(.data + .bss + .noinit)
		EEPROM:       64 bytes (12.5% Full)
		(.eeprom)

	Ђ : @cronos_sv

------------------------------------------------*/
//
// ToDo
// Lu[Vf[^̑Oԏ

/*------------------------------------------------

XV

v1.4:
	1. dLu[V𒆒fۂɁAf̓dosC
	   (Thanks @fuyuton)
	2. bR}h̎Ԍoߕ\32767bȍ~sƂȂs(x)C

v1.3:
	1. bR}h̎Ԍoߕ\32767bȍ~sƂȂsC
	2. bR}h֐ώZobeeʂ\@\ǉ
		PʂmAhƂȂ܂B

v1.2:
	1. bR}hEPR}h̃A{[g@\ǉ
	  [v"q" or "Q"͂ƋIƂB

v1.1:
	1. dwlDAClϊWbNC
	  (5mA25mACalf[^gĂȂFix)

v1.0:
	1. sR[h"CR+CR+LF"ɂȂĂ̂"CR+LF"ɏC
	2. o[WQƃR}hǉ(vR}h)
	3. R}hIɃvvg(ok)\悤C
	4. bR}hŏIoAI悤C

------------------------------------------------*/

/* Cu錾 */
#include <avr/io.h>
#include <stdlib.h>				// itoa()gp
//#include <avr/pgmspace.h>		// PROGMEMgp
//#include <stdio.h>
#include <avr/interrupt.h>
#include <avr/eeprom.h>			// AVREEPROMgp
#include <util/delay.h>
#include "Timer1_mega88p.H"		// ^C}
#include "integer.h"
#include "xitoa.h"
#include "uart.h"
#include "VL.h"
//#include "JJYDAT.h"				// JJYf[^p̐錾

//----------------------------------------------------------------
// ϐ`
//----------------------------------------------------------------

volatile unsigned int SCI_STR_EXIST = 0x00;					/* sf[^ꍇ"1" */
volatile unsigned int SCI_BYTES_READ = 0x00;				/* Mf[^TCY([N) */
volatile unsigned int SCI_DATASIZE = 0x00;					/* Mf[^TCY */
volatile unsigned char SCI_RX_DAT[SCI_RX_SIZE] = {0x00};	/* Mf[^ */
volatile unsigned int DEC_count = 0x00;						// fR[h
volatile unsigned int DAC_Code;
volatile unsigned int Current_Limit = Max_Current;			// d~bgݒ
volatile unsigned int CMD_Param = 0x00;
volatile unsigned int Iset = 0x00;
volatile unsigned int B_Volt = 0x00;
volatile unsigned int B_Curr = 0x00;
volatile unsigned int B_time = 0x00;
volatile unsigned int CMD_Data = 0x00;						// CV,CR,CP[hp[^󂯓n
volatile unsigned int CMD_Mode = 0x00;						// 샂[h󂯓n

//----------------------------------------------------------------
// EEPROMf[^`
// http://cega.jp/avr/avr-eeprom_h (QlɂURL)
//----------------------------------------------------------------

#define Cal_Point	6
#define Cal_Point_I	6
static unsigned int EEMEM Cal_ADC_V_fg;					// CaltO
static unsigned int EEMEM Cal_ADC_I_fg;					// CaltO
static unsigned int EEMEM Cal_Curr[Cal_Point];			// dlDACl
static unsigned int EEMEM Cal_ADC_V[Cal_Point];			// ADldl
static unsigned int EEMEM Cal_ADC_VAD[Cal_Point];		// ADldl
static unsigned int EEMEM Cal_ADC_I[Cal_Point_I];		// ADldl (dvl(10il)L^)
static unsigned int EEMEM Cal_ADC_IAD[Cal_Point_I];		// ADldl (ADClL^)

// eeprom_busy_wait();
//value = eeprom_read_word(&hoge);
//eeprom_write_word(&hoge_word, 0x55AA);
//eeprom_write_byte(&hoge_byte, 0xAA);

//---------------------------------------------------------------------------------
int main (void) {

	DEV_INIT();				// ӃfoCX

	int wk,voltage,current;
	int Volt , Curr , m_time , cmd_cnt = 0 , Curr_Step = 0;
	unsigned long power,reg;

	for(;;)
	{
		sci_recvln();							// f[^M

#ifdef	DEBUG
		xprintf(PSTR("DataSize = %u\n"),SCI_DATASIZE);	// f[^o
#endif

		if(SCI_DATASIZE==0){
			xputs(PSTR("ERROR\n"));				// f[^
		} else
		{
			switch(SCI_RX_DAT[0])
			{
				case 'b':							// obe胂[h
				case 'B':							// b "I~d[mV]" "דd[mA]" "Ԋu[Sec]"
					if(SCI_RX_DAT[1] != ' ')		// \`FbN 2="Xy[X"
					{
						break;
					}

					xputs(PSTR("ok\n"));
					cmd_cnt = 2;
					Volt = str2dec(cmd_cnt);			// dl(mVP)R}h璊o

					cmd_cnt = cmd_cnt + DEC_count + 1;
					Curr = str2dec(cmd_cnt);

					cmd_cnt = cmd_cnt + DEC_count + 1;
					m_time = str2dec(cmd_cnt);

					B_test(Volt , Curr , m_time);
				break;

				case 'p':							// dd胂[h
				case 'P':							// p "I~d[mA]" "hbvd[mV]" "dωXebv[mA]"
					if(SCI_RX_DAT[1] != ' ')		// \`FbN 2="Xy[X"
					{
						break;
					}

					xputs(PSTR("ok\n"));
					cmd_cnt = 2;
					Curr = str2dec(cmd_cnt);			// dl(mVP)R}h璊o

					cmd_cnt = cmd_cnt + DEC_count + 1;
					Volt = str2dec(cmd_cnt);

					cmd_cnt = cmd_cnt + DEC_count + 1;
					Curr_Step = str2dec(cmd_cnt);

					P_test(Curr , Volt , Curr_Step);
				break;

				case 'c':							// dhCu[h
				case 'C':
#ifdef	DEBUG
					xputs(PSTR("Load_Drive Mode\n"));
#endif
				if(SCI_RX_DAT[1] != ' ')		// \`FbN 2="Xy[X"
					{
						break;
					}
					
					switch(SCI_RX_DAT[2])			// TuR}h
					{
						case 'c':					// dhCu[h(c c )
						case 'C':
#ifdef	DEBUG
							xputs(PSTR("CC Mode\n"));
#endif
							if(SCI_RX_DAT[3] != ' ')		// \`FbN 4="Xy[X"
							{
								break;
							}

							xputs(PSTR("ok\n"));
							CMD_Param = str2dec(4);			// dl(mAP)R}h璊o
							VI_Out(CMD_Param);				// ddݒ

							break;
						case 'v':					// dhCu[h(c v )
						case 'V':
#ifdef	DEBUG
							xputs(PSTR("Continuous Voltage Mode\n"));
#endif
							if(SCI_RX_DAT[3] != ' ')		// \`FbN 4="Xy[X"
							{
								break;
							}
							xputs(PSTR("ok\n"));
							CMD_Param = str2dec(4);			// dl(mVP)R}h璊o
//							CVRP_Drv(CV_Mode,CMD_Param);

							break;
						case 'r':					// RhCu[h(c r )
						case 'R':
#ifdef	DEBUG
							xputs(PSTR("Continuous Resistance Mode\n"));
#endif
							if(SCI_RX_DAT[3] != ' ')		// \`FbN 4="Xy[X"
							{
								break;
							}
							xputs(PSTR("ok\n"));
							CMD_Param = str2dec(4);			// Rl(mP)R}h璊o
//							CVRP_Drv(CR_Mode,CMD_Param);

							break;
						case 'p':					// d̓hCu[h(c p )
						case 'P':
#ifdef	DEBUG
							xputs(PSTR("Continuous Power Mode\n"));
#endif
							if(SCI_RX_DAT[3] != ' ')		// \`FbN 4="Xy[X"
							{
								break;
							}
							xputs(PSTR("ok\n"));
							CMD_Param = str2dec(4);			// dl(mWP)R}h璊o
//							CVRP_Drv(CP_Mode,CMD_Param);

							break;
						case 'd':					// hCu~(c d )
						case 'D':
#ifdef	DEBUG
							xputs(PSTR("Drive_Disable\n"));
#endif
							xputs(PSTR("ok\n"));
							VI_Out(0);				// dhCu~

							break;

						case 'l':					// hCu~(c d )
						case 'L':
#ifdef	DEBUG
							xputs(PSTR("Current_Limit\n"));
#endif
							if(SCI_RX_DAT[3] != ' ')		// \`FbN 4="Xy[X"
							{
								break;
							}
							xputs(PSTR("ok\n"));
							CMD_Param = str2dec(4);			// dl(mWP)R}h璊o
							Current_Limit = CMD_Param;		// d~bglݒ
							break;

						default:
							xputs(PSTR("ERROR\n"));
							break;
					}
					break;
				case 'r':
				case 'R':
#ifdef	DEBUG
					xputs(PSTR("Monitor Mode\n"));
#endif
					xputs(PSTR("ok\n"));
					voltage = V_Mon();						// ͓d
					current = I_Mon();						// d
					power = (unsigned long)(((double)voltage / 1000) * current);		// d͎Z
					reg = (unsigned long)((double)voltage / ((double)current / 1000));	// RlZ

					if(SCI_RX_DAT[1] == 'm' || SCI_RX_DAT[1] == 'M')		// }V\
					{
#ifdef	DEBUG
						xputs(PSTR("setting, voltage, current, power, registance\n"));
#endif
						xprintf(PSTR("%d,%u,%d,%lu,%lu\n"),Iset,voltage,current,power,reg);
						break;
					}

					xprintf(PSTR("Setting = %u [mA]\n"),Iset);		// ݒl\
					xprintf(PSTR("ILimit = %u [mA]\n"),Current_Limit);	// d~bg\
					xprintf(PSTR("VMon = %u [mV]\n"),voltage);			// d\
					xprintf(PSTR("IMon = %u [mA]\n"),current);			// d\
					xprintf(PSTR("PMon = %lu [mW]\n"),power);			// d͕\
					xprintf(PSTR("RMon = %lu [mohm]\n"),reg);			// Rl\
					break;
				case 'v':
				case 'V':
					xputs(PSTR("ok\n"));
					xputs(PSTR("Virtual Load ver1.4\n"));
					break;
				case 'x':
				case 'X':
//					xputs(PSTR("Calibration Mode\n"));
					if(SCI_RX_DAT[1] != ' ')		// \`FbN 2="Xy[X"
					{
						break;
					}
					
					switch(SCI_RX_DAT[2])			// TuR}h
					{
						case 'i':					// dLu[V[h
						case 'I':
							xputs(PSTR("ok\n"));
							xputs(PSTR("Current Calibration Mode\n"));

							SCI_STR_EXIST = 0;		// f[^܂tO낷
							I_Calib();
							break;

						case 'v':					// dLu[V[h
						case 'V':
							xputs(PSTR("ok\n"));
							xputs(PSTR("Voltage Calibration Mode\n"));

							SCI_STR_EXIST = 0;		// f[^܂tO낷
							V_Calib();
							break;

						case 'c':					// EEPROMf[^NA
						case 'C':
							xputs(PSTR("ok\n"));
							xputs(PSTR("Calibration Data Erase\n"));
							
							clreeprom();
							break;

						case 'd':					// EEPROMf[^_v
						case 'D':
							xputs(PSTR("ok\n"));
							xputs(PSTR("Calibration Data Dump\n"));
							
							eedump();
							break;

						default:
							xputs(PSTR("ERROR\n"));
							break;
					}				
					break;
				default:
					xputs(PSTR("ERROR\n"));
					break;
			}
		}
		SCI_STR_EXIST = 0;					// f[^܂tO낷
	}
}
//---------------------------------------------------------------------------------

/* ^C}1荞ݏ */
SIGNAL(TIMER1_OVF_vect) {

/* ^C}l̐ݒ */
	TCNT1 = PI_TCNT1;

// CV,CR,CP̃[vɋLqB
// switchŏe̕sB

	if(Iset == 0)
	{
		PORTB &= ~_BV(LED);
	}else
	{
		PORTB |= _BV(LED);
	}

}


void delay_us(int time)
{
	while(time--)
	{
		_delay_us(1);
	}
}

void delay_ms(int time)
{
	while(time--)
	{
		_delay_ms(1);
	}
}

void delay_sec(int time)
{
	while(time--)
	{
		_delay_ms(1000);
	}
}

//----------------------------------------------------------------
// d
//@肽FeXgIdAhbvdA蕉דdXebv^
//@@@@@@דd-o͓d̑sB
//----------------------------------------------------------------
void P_test(int Curr ,int Volt ,int Curr_Step)
{
	int wk, mon_Volt;
	int start_Volt , wk_curr = 0;
	char cmd;
	
	B_Volt = Volt;
	B_Curr = Curr;

	xprintf(PSTR("Exit Current : %d [mA]\n"),B_Curr);
	xprintf(PSTR("Voltage Setting : %d [mV]\n"),B_Volt);
	xprintf(PSTR("Current_Step : %d [mA]\n"),Curr_Step);

	delay_sec(1);

	xputs(PSTR("\n"));
	xputs(PSTR("Current [mA] , Voltage [mV]\n"));

	start_Volt = V_Mon();
	mon_Volt = start_Volt;

	while(mon_Volt > (start_Volt - B_Volt))
	{
		xprintf(PSTR("%d , "),wk_curr);			// דd\
		mon_Volt = V_Mon();
		xprintf(PSTR("%d , "),mon_Volt);		// d\
		wk = I_Mon();
		xprintf(PSTR("%d\n"),wk);				// j^d\

		if(!bit_is_clear(UCSR0A, RXC0))
		{
			cmd = uart_get();					// f[^M
			switch(cmd)
			{
				case 'q':						// I
				case 'Q':
					wk_curr = Max_Current;		// p[h~
					break;
				default:
					break;
			}
		}
		if(wk_curr > Max_Current || wk_curr >= B_Curr) break;
		wk_curr = wk_curr + Curr_Step;
		VI_Out(wk_curr);								// ddݒ
		delay_ms(500);
	}
	VI_Out(0);			// dhCuOFF
	xputs(PSTR("ok\n"));
}

//----------------------------------------------------------------
// obe
//@肽FeXgIdAדdA莞ԊԊu^
//@@@@@@dŃobed̑sB
//----------------------------------------------------------------
void B_test(int Volt ,int Curr ,int m_time)
{
	int wk, mon_Volt;
	unsigned long w_time = 0;
	char cmd;
	B_Volt = Volt;
	B_Curr = Curr;
	B_time = m_time;		// 莞ԊԊu(PSec)
	double B_Capa = 0;		// e

	xprintf(PSTR("Exit Voltage : %d [mV]\n"),B_Volt);
	xprintf(PSTR("Current Setting : %d [mA]\n"),B_Curr);
	xprintf(PSTR("Time Interval : %d [Sec]\n"),B_time);

	mon_Volt = V_Mon();
	if (mon_Volt > B_Volt)
	{
		VI_Out(B_Curr);								// ddݒ
		delay_ms(100);

		xputs(PSTR("\n"));
		xputs(PSTR("Time [Sec] , Voltage [mV] , Current [mA] , Capacity [mAh]\n"));

		while(mon_Volt > B_Volt)
		{
			xprintf(PSTR("%u , "),w_time);			// oߎԕ\
			mon_Volt = V_Mon();
			xprintf(PSTR("%d , "),mon_Volt);		// d\
			wk = I_Mon();
			xprintf(PSTR("%d , "),wk);				// d\

			xprintf(PSTR("%d\n"),(int)B_Capa);		// d\
			B_Capa = ((double)wk * ((double)B_time / 3600)) + B_Capa;			// eʌvZ(mAh)

			if (mon_Volt > B_Volt)
			{
				delay_sec(B_time);					// w莞Ԃ҂
			}
			w_time = w_time + B_time;

			if(!bit_is_clear(UCSR0A, RXC0))
			{
				cmd = uart_get();				// f[^M
				switch(cmd)
				{
					case 'q':					// I
					case 'Q':
						B_Volt = 65535;			// b[h~
						break;
					default:
						break;
				}
			}
		}
		VI_Out(0);			// dhCuOFF
		B_Capa = 0;
		xputs(PSTR("ok\n"));
	} else 
	{
		xputs(PSTR("Voltage_Error\n"));
	}
}

//----------------------------------------------------------------
// dLu[V
//@肽F̓dlƁA{[hŌoADle[uɎB
//----------------------------------------------------------------
void V_Calib(void)
{
	int wk, i, j, Voltage, CMD_Volt, cmd_cnt = 0;
	unsigned long AD_dat;

// OF0`5Vx܂œdϏodpӂB
// 100mV , 1.5V , 3.0V , 4.5V 4|Cgɂēd(l)
// ADC̃j^lEEPROMɋL^B
// L^́Adj^ɒߎɂdZoɎgpB

	VI_Out(0);								// dhCu߂

	eeprom_busy_wait();
	eeprom_write_word(&Cal_ADC_V_fg,NG);		// CalibσtO܂B

	for (i=0; i<Cal_Point; i++)
	{
		AD_dat = 0;
		
		Voltage = pgm_read_word(&Cal_V[i]);
		xprintf(PSTR("Please supply Voltage. Recommend setting it %u [mV] : "),Voltage);
		sci_recvln();							// f[^M
		if(SCI_DATASIZE==0){
			xputs(PSTR("ERROR\n"));			// f[^
			break;
		} else
		{
			CMD_Volt = str2dec(cmd_cnt);				// dl(mVP)R}h璊o
			xprintf(PSTR("CMD_V: %u [mV]\n"),CMD_Volt);
			eeprom_busy_wait();
			eeprom_write_word(&Cal_ADC_V[i],CMD_Volt);	// eLXg͂ꂽdlL^

			xprintf(PSTR("Loop: %u , "),i);
			xprintf(PSTR("CMD_V: %u [mV] , "),CMD_Volt);
			
//			wk = ADC_Read(AD_Vmon);

			for (j=0; j<32; j++)
			{
				AD_dat = AD_dat + ADC_Read(AD_Vmon);
			}
				wk = AD_dat / 32;

			xprintf(PSTR("AD_Vmon: %u [LSB]\n"),wk);

			eeprom_busy_wait();
			eeprom_write_word(&Cal_ADC_VAD[i],wk);	// ADlL^

		}
		SCI_STR_EXIST = 0;					// f[^܂tO낷
	}
	if(i==Cal_Point)
	{
		eeprom_busy_wait();
		eeprom_write_word(&Cal_ADC_V_fg,OK);	// SĐtOĂB
	}

}

//----------------------------------------------------------------
// dLu[V
//@肽F̓dlƁA{[hŌoADle[uɎB
//----------------------------------------------------------------
void I_Calib(void)
{
// 1. ɓdhCuĂ\̂ŁAdݒ0ɂB
// 2. 500mA݂5A܂ŁAdƓd𑪒őAl͂B
// 3. ͂l璼ߎŋtZB
	int wk, i, j, Current, DAC_Code, CMD_Current, cmd_cnt = 0;
	unsigned long AD_dat;

// OF0`5Vx܂œdϏodpӂB
// 100mV , 1.5V , 3.0V , 4.5V 4|Cgɂēd(l)
// ADC̃j^lEEPROMɋL^B
// L^́Adj^ɒߎɂdZoɎgpB

//	VI_Out(0);
	DAC_DataOut(DA_DACA_Vout , DA_DACB_V);		// do0ݒ

	eeprom_busy_wait();
	eeprom_write_word(&Cal_ADC_I_fg,NG);		// CalibσtO܂B

	for (i=0; i<Cal_Point_I; i++)
	{
		AD_dat = 0;
		DAC_Code = pgm_read_word(&Cal_DA_I[i]);
//		xprintf(PSTR("Please input Measure Current. Setting to %u [mA] : "),DAC_Code);
		DAC_DataOut(DA_DACA_Vout , DAC_Code);				// e[ulœdo

		Current = pgm_read_word(&Cal_I[i]);
		xprintf(PSTR("Please input Measure Current. Setting to %u [mA] : "),Current);
		sci_recvln();										// f[^M
		if(SCI_DATASIZE==0){
			xputs(PSTR("ERROR\n"));							// f[^
			break;
		} else
		{
			CMD_Current = str2dec(cmd_cnt);					// dl(mAP)R}h璊o
			xprintf(PSTR("CMD_I: %u [mA]\n"),CMD_Current);
			eeprom_busy_wait();
			eeprom_write_word(&Cal_ADC_I[i],CMD_Current);	// eLXg͂ꂽdlL^

			xprintf(PSTR("Loop: %u , "),i);
			xprintf(PSTR("CMD_I: %u [mA] , "),CMD_Current);
			
//			wk = ADC_Read(AD_Vmon);

			for (j=0; j<32; j++)
			{
				AD_dat = AD_dat + ADC_Read(AD_Imon);
			}
				wk = AD_dat / 32;

			xprintf(PSTR("AD_Imon: %u [LSB]\n"),wk);

			eeprom_busy_wait();
			eeprom_write_word(&Cal_ADC_IAD[i],wk);	// ADlL^

		}
		SCI_STR_EXIST = 0;							// f[^܂tO낷
	}
	if(i==Cal_Point_I)
	{
		eeprom_busy_wait();
		eeprom_write_word(&Cal_ADC_I_fg,OK);		// SĐtOĂB
	}

	VI_Out(0);										// d0ɖ߂B

// eeprom_busy_wait();
//value = eeprom_read_word(&hoge);
//eeprom_write_word(&hoge_word, 0x55AA);
//eeprom_write_byte(&hoge_byte, 0xAA);
//value = Cal_AD_Iset[]
//value = Cal_DA_Vmon[]

}

//----------------------------------------------------------------
// dv
//@肽FADldl(mV)ɕϊA߂lƂĕԂB
//----------------------------------------------------------------
int V_Mon(void)
{
	int wk = 0,i;
	long Cal_V_Upper, Cal_V_Lower, Cal_VAD_Upper, Cal_VAD_Lower , AD_dat = 0;

//	wk = ADC_Read(AD_Vmon);
//	wk = ((double)wk / ((double)AD_FSR / AD_Vref)) * (double)17.12903;			// mVPʂœdɕϊ (17.12903=((10M+620k)/620k))

	eeprom_busy_wait();
	if(eeprom_read_word(&Cal_ADC_V_fg))
	{
		for (i=0; i<4; i++)
		{
			AD_dat = AD_dat + ADC_Read(AD_Vmon);
		}
		AD_dat = AD_dat / 4;
#ifdef DEBUG
		xprintf(PSTR("VMon_AD = %u [LSB]\n"),AD_dat);
#endif
		for (i=0; i<=(Cal_Point-2); i++)
		{
			eeprom_busy_wait();
			Cal_V_Lower = eeprom_read_word(&Cal_ADC_V[i]);			//d[V] X1
			eeprom_busy_wait();
			Cal_V_Upper = eeprom_read_word(&Cal_ADC_V[i+1]);		//d[V] X2
			eeprom_busy_wait();
			Cal_VAD_Lower = eeprom_read_word(&Cal_ADC_VAD[i]);		//ADCf[^[V] Y1
			eeprom_busy_wait();
			Cal_VAD_Upper = eeprom_read_word(&Cal_ADC_VAD[i+1]);	//ADCf[^[V] Y2

			if (((i==0) && (AD_dat < Cal_VAD_Lower)) || ((AD_dat >= Cal_VAD_Lower) && (AD_dat <= Cal_VAD_Upper)) || ((i==(Cal_Point-2)) && (AD_dat > Cal_VAD_Upper)))
			{
				wk = (int)((double)Cal_V_Lower + ((((double)Cal_V_Upper - Cal_V_Lower)*((double)AD_dat - Cal_VAD_Lower)) / ((double)Cal_VAD_Upper - Cal_VAD_Lower)));
			}
		}
	} else
	{
		xputs(PSTR("### ERR : Voltage is not calibrate\n"));
	}
	return wk;
}

//----------------------------------------------------------------
// dv
//@肽FADldl(mA)ɕϊA߂lƂĕԂB
//----------------------------------------------------------------
int I_Mon(void)
{
	int wk = 0,i;
	long Cal_I_Upper, Cal_I_Lower, Cal_IAD_Upper, Cal_IAD_Lower , AD_dat = 0;

//	wk = ADC_Read(AD_Vmon);
//	wk = ((double)wk / ((double)AD_FSR / AD_Vref)) * (double)17.12903;			// mVPʂœdɕϊ (17.12903=((10M+620k)/620k))

	eeprom_busy_wait();
	if(eeprom_read_word(&Cal_ADC_I_fg))
	{
		for (i=0; i<4; i++)
		{
			AD_dat = AD_dat + ADC_Read(AD_Imon);
		}
		AD_dat = AD_dat / 4;
		
		for (i=0; i<=(Cal_Point_I-2); i++)
		{
			eeprom_busy_wait();
			Cal_I_Lower = eeprom_read_word(&Cal_ADC_I[i]);			//d[mA] X1
			eeprom_busy_wait();
			Cal_I_Upper = eeprom_read_word(&Cal_ADC_I[i+1]);		//d[mA] X2
			eeprom_busy_wait();
			Cal_IAD_Lower = eeprom_read_word(&Cal_ADC_IAD[i]);		//ADCf[^[I] Y1
			eeprom_busy_wait();
			Cal_IAD_Upper = eeprom_read_word(&Cal_ADC_IAD[i+1]);	//ADCf[^[I] Y2

			if (((i==0) && (AD_dat < Cal_IAD_Lower)) || ((AD_dat >= Cal_IAD_Lower) && (AD_dat <= Cal_IAD_Upper)) || ((i==(Cal_Point-2)) && (AD_dat > Cal_IAD_Upper)))
			{
				wk = (int)((double)Cal_I_Lower + ((((double)Cal_I_Upper - Cal_I_Lower)*((double)AD_dat - Cal_IAD_Lower)) / ((double)Cal_IAD_Upper - Cal_IAD_Lower)));
			}
		}
	} else
	{
		xputs(PSTR("### ERR : Current is not calibrate\n"));
	}
	return wk;

//	long wk;
//
//	wk = ADC_Read(AD_Imon);
////	xprintf(PSTR("IDAT = %d [LSB]\n"),wk);
//	wk = (((double)wk / ((double)AD_FSR / AD_Vref)) - DAC_Vos) / ((double)VI_Rs/1000) / Imon_Gain;			// mVPʂœdɕϊ (17.12903=((10M+620k)/620k))
//	return wk;
}

//----------------------------------------------------------------
// EEPROMf[^_v
//@肽FeϐɃLu[VlǂݏoB
//----------------------------------------------------------------
void eedump(void)
{
	int wk = 0,i;
	long Cal_V, Cal_VAD, Cal_I, Cal_IAD;

		xputs(PSTR("Cal_ADC_V_fg : "));
		eeprom_busy_wait();
		wk = eeprom_read_word(&Cal_ADC_V_fg);
		xprintf(PSTR(" %X\n"),wk);

		xputs(PSTR("Cal_ADC_V : "));
		for (i=0; i<Cal_Point; i++)
		{
			eeprom_busy_wait();
			Cal_V = eeprom_read_word(&Cal_ADC_V[i]);
			xprintf(PSTR(" %d"),Cal_V);
		}
		xputs(PSTR("\n"));

		xputs(PSTR("Cal_ADC_VAD : "));
		for (i=0; i<Cal_Point; i++)
		{
			eeprom_busy_wait();
			Cal_VAD = eeprom_read_word(&Cal_ADC_VAD[i]);
			xprintf(PSTR(" %X"),Cal_VAD);
		}
		xputs(PSTR("\n"));

		xputs(PSTR("Cal_ADC_I_fg : "));
		eeprom_busy_wait();
		wk = eeprom_read_word(&Cal_ADC_I_fg);
		xprintf(PSTR(" %X\n"),wk);

		xputs(PSTR("Cal_ADC_I : "));
		for (i=0; i<Cal_Point_I; i++)
		{
			eeprom_busy_wait();
			Cal_I = eeprom_read_word(&Cal_ADC_I[i]);
			xprintf(PSTR(" %d"),Cal_I);
		}
		xputs(PSTR("\n"));

		xputs(PSTR("Cal_ADC_IAD : "));
		for (i=0; i<Cal_Point_I; i++)
		{
			eeprom_busy_wait();
			Cal_IAD = eeprom_read_word(&Cal_ADC_IAD[i]);
			xprintf(PSTR(" %X"),Cal_IAD);
		}
		xputs(PSTR("\n"));

}

//----------------------------------------------------------------
// EEPROMNA
//@肽FEEPROM̑SsB
//----------------------------------------------------------------
void clreeprom(void)
{
	int i;

	eeprom_busy_wait();
	eeprom_write_word(&Cal_ADC_V_fg,0);
	eeprom_busy_wait();
	eeprom_write_word(&Cal_ADC_I_fg,0);

	for(i=0;i<Cal_Point;i++)
	{
		eeprom_busy_wait();
		eeprom_write_word(&Cal_Curr[i],0);
		eeprom_busy_wait();
		eeprom_write_word(&Cal_ADC_V[i],0);
		eeprom_busy_wait();
		eeprom_write_word(&Cal_ADC_VAD[i],0);
		eeprom_busy_wait();
		eeprom_write_word(&Cal_ADC_I[i],0);
		eeprom_busy_wait();
		eeprom_write_word(&Cal_ADC_IAD[i],0);

	}
}

//----------------------------------------------------------------
// SCI_Rx s擾
//@肽Fs`s(CRo)܂ł̕zɋl߂ĕԂB
//@@@@@@BS1폜 ͎B
//@@@@@@sF_Ń^[R[h"1"ԂB
//----------------------------------------------------------------
void sci_recvln(void)
{
	while(SCI_STR_EXIST == 0)						// s܂ŌJԂ
	{
		char d = uart_get();
//		xputs(PSTR(d);
//		if(SCI_STR_EXIST) return;				// Ɋf[^āȀꍇ͌㑱𖳎B
//		else if(d == '\r'){						// s(CR)
		if(d == '\r'){							// s(CR)
			SCI_RX_DAT[SCI_BYTES_READ] = '\0';	// NullGhR[hƂďB
			SCI_DATASIZE = SCI_BYTES_READ;
			SCI_BYTES_READ = 0;					// MɔMf[^TCYNA
			SCI_STR_EXIST = 1;					// f[^܂tO𗧂Ă
			xputs(PSTR("\n"));					// GR[obN(s)
//			break;
		}
		else if(d == '\b'){						// obNXy[X(BS)
			if(SCI_BYTES_READ > 0){				// obt@Ƀf[^L
				xputs(PSTR("\b \b"));			// ʏłf[^
				SCI_BYTES_READ--;				// obt@̃f[^1炷
			}
//			break;
		}
		else if(SCI_BYTES_READ >= SCI_RX_SIZE){	// MTCYobt@TCY𒴂
			xputs(PSTR("Size Over\n"));		// f[^I
			SCI_BYTES_READ = 0;					// MɔMf[^TCYNA
//			break;
		}
		else if(d >= 0x20 && d <= 0x7E){		// (p)
			SCI_RX_DAT[SCI_BYTES_READ] = d;		// ̂܂܃f[^ƂĐςށB
			SCI_BYTES_READ++;
			uart_put(d);						// echo back
		}
	}
	return;
}

//----------------------------------------------------------------
// SPI Byte]
//@肽F1ByteoƓɃf[^󂯎
//@@@@@@Mf[^^[f[^ƂĕԂB
// SPI_MISO		PINC4	// for ADC/DAC(i)
// SPI_MOSI		PINC3	// for ADC/DAC(o)
// SPI_SCLK		PINC2	// for ADC/DAC(o)
//----------------------------------------------------------------
int SPI_byte_io(int tx_dat)
{
	int i , rxdat = 0;
	int	tx_shift = 0x80;				// Txf[^}XN

	PORTC |= _BV(SPI_SCLK);				// NbNԂm(HŒ)

	for(i=1;i<=8;i++)
	{
		if(tx_dat & tx_shift)			// MOSI
		{
			PORTC |= _BV(SPI_MOSI);		// Ho
		} else {
			PORTC &= ~_BV(SPI_MOSI);	// Lo
		}
		tx_shift = tx_shift >> 1;		// Txf[^p(}XNړ)

		PORTC |= _BV(SPI_SCLK);			// LH
		delay_us(1);
		PORTC &= ~_BV(SPI_SCLK);		// HL

		if(PINC & _BV(SPI_MISO)){		// MISOs̎Mf[^WX^ɐςށB
			rxdat = (rxdat << 1) + 1;
		} else {
			rxdat = (rxdat << 1) + 0;
		}
	}

	delay_us(1);
	PORTC |= _BV(SPI_SCLK);

	return rxdat;
}

//----------------------------------------------------------------
// d萧
//@肽FADC_Vj^Aj^dƂȂ悤䂷B
//----------------------------------------------------------------
void CVRP_Drv(int Mode , int Param)						// d萧
{

// ^C}荞݂𗘗pāA䃋[v񂷁B
// Y֐ł́A荞ݓ̐֐Ƀp[^n݂̂sB
// ̓Iɂ͈ȉ̏sB
// R[̏ʊ֐p[^󂯁A荞ݓ̐֐ɓnB
// 荞݂(ɋĂāAEND_Mode͉Ȃ悤ɂ悤B)
// R}h͑҂ƂȂAȉ̃R}h҂󂯂B
// "P "󂯎wl̕ύX
// "R"󂯎猻̃j^l
// "D"󂯎琧I(荞݋֎~Ao͓d0w)
// "H"󂯎AR}hV^bNXԂB
// ȊȌꍇ͏ԕύXȂApB

	int wk;

	CMD_Data = Param;
	CMD_Mode = Mode;

	while(1)
	{
		sci_recvln();							// f[^M

	#ifdef	DEBUG
		xprintf(PSTR("DataSize = %u\n"),SCI_DATASIZE);	// f[^o
	#endif

		if(SCI_DATASIZE==0){
			xputs(PSTR("ERROR\n"));				// f[^
		} else
		{
			switch(SCI_RX_DAT[0])
			{
				case 'p':							// wlύX
				case 'P':							// p "[d[mV]/R[m]/d[mW]"
					if(SCI_RX_DAT[1] != ' ')		// \`FbN 2="Xy[X"
					{
						break;
					}

					xputs(PSTR("ok\n"));
					CMD_Data = str2dec(4);			// d/R/d͒l(mV/m/mWP)R}h璊o

				break;

				case 'r':							// j^l擾
				case 'R':							//
					xputs(PSTR("ok\n"));
					wk = ADC_Read(AD_Vmon);
					xprintf(PSTR("V,%u,[mV]\n"),wk);
					wk = ADC_Read(AD_Vmon) / ADC_Read(AD_Imon);
					xprintf(PSTR("R,%u,[mohm]\n"),wk);
					wk = (int)(((double)ADC_Read(AD_Vmon)/1000) * ADC_Read(AD_Imon));
					xprintf(PSTR("P,%u,[mW]\n"),wk);

				break;

				case 'd':							// d͐I
				case 'D':							//
					xputs(PSTR("ok\n"));
					CMD_Mode = END_Mode;
					delay_ms(100);
					VI_Out(0);								// dhCu߂
					return;
				break;

				case 'h':							// R}hV^bNX\
				case 'H':							//
					xputs(PSTR("ok\n"));
					xputs(PSTR("### Command Syntax ###\n"));
					xputs(PSTR("P (Parameter[mV/mohm/mW])\n"));
					xputs(PSTR("R : V/R/P Monitoring\n"));
					xputs(PSTR("D : Drive Disable\n"));
				break;

				default:
					xputs(PSTR("ERROR\n"));
					break;
			}
		}
		SCI_STR_EXIST = 0;					// f[^܂tO낷
	}
}

//----------------------------------------------------------------
// DACf[^](dlw)
//@肽FDAC̃f[^tH[}bgɉăf[^o͂B
// DAC_SYNCN	PINC1	// chip select(o)
//----------------------------------------------------------------
void VI_Out(int Current)
{
	int i;
	long Cal_I_Upper, Cal_I_Lower, Cal_IDA_Upper, Cal_IDA_Lower;


	if(Current < 0 || Current >= Max_Current + 1)			// ődlȏ̐ݒlWFNg
	{
		xprintf(PSTR("Invalid Current Value : %u [mA]\n"),Current);
	} else
	{
//		DAC_Code = (Current / (((DAC_Vref - DAC_Vos) / VI_Gain) / ((double)VI_Rs / 1000)))*(DAC_Res - DA_DACB_V) + DA_DACB_V;

		 if (Current > Current_Limit)				// ݒld~bgl傫ꍇA~bglɐ
		{
			Current = Current_Limit;
		}

		eeprom_busy_wait();
		if(eeprom_read_word(&Cal_ADC_I_fg))
		{
			Iset = Current;
			if (Iset == 0)							// ݒl0mȀꍇDACl0x0ɐݒAG[Aṽhtgɂd[Nj~B
			{
				DAC_Code = 0;
			}else
			{
				for (i=0; i<=(Cal_Point-2); i++)
				{
					eeprom_busy_wait();
					Cal_I_Lower = eeprom_read_word(&Cal_ADC_I[i]);			//d[mA] X1 (Call)
					eeprom_busy_wait();
					Cal_I_Upper = eeprom_read_word(&Cal_ADC_I[i+1]);		//d[mA] X2 (Call)
					Cal_IDA_Lower = pgm_read_word(&Cal_DA_I[i]);			//DACf[^[I] Y1 (萔)
					Cal_IDA_Upper = pgm_read_word(&Cal_DA_I[i+1]);			//DACf[^[I] Y2 (萔)
//120805_cronos		if (((i==0) && (Current < Cal_IDA_Lower)) || ((Current >= Cal_IDA_Lower) && (Current <= Cal_IDA_Upper)) || ((i==(Cal_Point-2)) && (Current > Cal_IDA_Upper)))
					if (((i==0) && (Current <= Cal_I_Lower)) || ((Current >= Cal_I_Lower) && (Current <= Cal_I_Upper)) || ((i==(Cal_Point-2)) && (Current >= Cal_I_Upper)))
					{
						DAC_Code = (int)((double)Cal_IDA_Lower + ((((double)Cal_IDA_Upper - Cal_IDA_Lower)*((double)Iset - Cal_I_Lower)) / ((double)Cal_I_Upper - Cal_I_Lower)));
					}
				}
			}
		DAC_DataOut(DA_DACA_Vout , DAC_Code);				// ddݒlo
#ifdef	DEBUG
		xprintf(PSTR("Setting_Value : %u [mA]"),Iset);
		xprintf(PSTR(" , DAT : %X\n"),DAC_Code);
#endif
		} else
		{
			xputs(PSTR("### ERR : Current is not calibrate\n"));
			DAC_DataOut(DA_DACA_Vout , DA_DACB_V);			// d0ݒ
		}
	}
}

//----------------------------------------------------------------
// DACf[^] (SPIx)
//@肽FDAC̃f[^tH[}bgɉăf[^o͂B
// DAC_SYNCN	PINC1	// chip select(o)
//----------------------------------------------------------------
void DAC_DataOut(int DA_Command , int DA_Data)
{
	int DA_Data_H = DA_Data;
	int DA_Data_L = DA_Data;
	
	PORTC &= ~_BV(DAC_SYNCN);			// ChipSelect
		SPI_byte_io(DA_Command);		// DACR}h]
		SPI_byte_io(DA_Data_H >> 8);	// ʃoCg]
		SPI_byte_io(DA_Data_L);			// ʃoCg]
	PORTC |= _BV(DAC_SYNCN);			// ChipSelect
}

//----------------------------------------------------------------
// ADCWX^
//@肽FADC̃f[^tH[}bgɉďݒ背WX^֏o͂B
// ADC_CSN			PINC0	// chip select(o)
//----------------------------------------------------------------
void ADC_WriteReg(int AD_Adrs , int AD_Cmd)
{
	int AD_WREG = (AD_Adrs & 0x0f) | 0x40;

	PORTC &= ~_BV(ADC_CSN);				// ChipSelect
		SPI_byte_io(AD_WREG);			// AD_WREG
		SPI_byte_io(0);					// f[^=1Byte
		SPI_byte_io(AD_Cmd);			// R}hM
	PORTC |= _BV(ADC_CSN);				// ChipSelect
}

//----------------------------------------------------------------
// ADCϊlǂݍ
//@肽FADCAw肵`l̃f[^擾B
//@@@@@@f[^́A߂lƂĕԂB
// ADC_CSN			PINC0	// chip select(o)
//----------------------------------------------------------------
int ADC_Read(int AD_Ch)
{
	int wk;
	int AD_Data = 0;

	ADC_WriteReg(AD_MUX0 , AD_Ch);				// ̓`lI
	delay_ms(10);								// `lؑ֌f[^ϊ

	PORTC &= ~_BV(ADC_CSN);						// ChipSelect
		SPI_byte_io(AD_RDATA);					// AD_WREG
		wk = SPI_byte_io(0xFF) << 8;		// ADϊlǂݍ (b23-b16)
		AD_Data = wk | (SPI_byte_io(0xFF) & 0x00FF);	// ADϊlǂݍ (b15-b8)
		// foCXƂẮA{S24bit̃f[^o͂dlAo̓f[^[gI
		// Lf[^16.8bit(@160SPS)ƂȂ邽߁Ac8bit͐؂̂Ă16bitlƂĕԂB
	PORTC |= _BV(ADC_CSN);						// ChipSelect
	return AD_Data;
}

//----------------------------------------------------------------
// ASCIIzf[^intϐ
//@肽FUART瓾R}hAŎw肵JnoCg
//@@@@@@I(\r or \0)܂ł̒l𐔒lƂĕԂB
//@@@@@@f[^́A߂lƂĕԂB
//----------------------------------------------------------------
int str2dec(int start_byte)
{
	int i, j, wk;
	int dec_num = 0;
	int end_byte = 0;
	char num_dat[str2dec_buf_size] = {0x00};

	for (i=start_byte;i<=str2dec_buf_size;i++)
	{
//		if(SCI_RX_DAT[i] == '\r' || SCI_RX_DAT[i] == '\0')
		if(SCI_RX_DAT[i] == '\r' || SCI_RX_DAT[i] == '\0' || SCI_RX_DAT[i] == ' ')
		{
			end_byte = i - 1;
			break;
		}
	}

	if(i == start_byte) return 0;		// ȂI
	DEC_count = i - start_byte;			// ȊO͉̎JEg

	if(end_byte < DEC_count)
	{
		wk = 0;
	} else
	{
		wk = (end_byte - DEC_count);
	}

	j = 0;
	for(i = end_byte; i >= wk; i--)
	{
		if (wk == 0)
		{
			num_dat[i] = SCI_RX_DAT[i];
		} else
		{
			num_dat[DEC_count - j] = SCI_RX_DAT[i+1];
		}

		j++;
	}
	dec_num = atoi(num_dat);
	return dec_num;
}

//----------------------------------------------------------------
// ӃfoCX
//----------------------------------------------------------------
void DEV_INIT(void)
{
/* ### IO-port ### */
/* o̓xlݒ */
	PORTB = 0b00000001;	// A/D , LED
	PORTC = 0b00101111;	// A/D , D/A
	PORTD = 0b00000010; // UART

/* 0:input , 1:output */
	DDRB = 0b00000100;	// A/D , LED
	DDRC = 0b00101111;	// A/D , D/A
	DDRD = 0b11111110;	// UART


/* 荞ݏ */
Int_intrp(PI_TCNT1);
uart_init();   			// SIOݒ
xfunc_out = uart_put;	// xitoa.s̏o͐foCXw

sei();

	delay_ms(100);
/* DAC */
	DAC_DataOut(DA_DAC_Reset , 0x0001);		// DAC SWX^
	delay_ms(10);
	DAC_DataOut(DA_DAC_RefEN , 0x0001);		// DAC RefL
	delay_ms(10);
	DAC_DataOut(DA_DAC_Gain , 0x0003);		// DAC Gain = 1 (A&B)
	delay_ms(1);
	DAC_DataOut(DA_DAC_LDAC , 0x0003);		// synchronous mode (A&B)
	DAC_DataOut(DA_DACB_Vout , DA_DACB_V);	// doCAXdo
	VI_Out(0);

/* ADC */
	PORTC &= ~_BV(ADC_RSTN);				// ADCZbgs
	delay_us(10);
	PORTC |= _BV(ADC_RSTN);
	delay_ms(3);							// Zbg҂

	ADC_WriteReg(AD_MUX1,AD_MUX1_Data);
	delay_us(500);
	ADC_WriteReg(AD_SYS0,AD_SYS0_Data);

	DEF_Check();							// ݒlmF
}

void DEF_Check(void)
{
	if (SCI_RX_SIZE > str2dec_buf_size)
	{
		xputs(PSTR("[ ERR ] str2dec_buf_size too small.\n"));
	}
}
