//----------------------------------------------------------------
// |[g`
//----------------------------------------------------------------

/* SPI|[gw */
#define SPI_MISO		PINC4	// for ADC/DAC(i)
#define	SPI_MOSI		PINC3	// for ADC/DAC(o)
#define	SPI_SCLK		PINC2	// for ADC/DAC(o)

/* ADC */
#define ADC_CSN			PINC0	// chip select(o)
#define	ADC_RSTN		PINC5	// Device Reset(o)
#define	ADC_DRDYN		PINB0	// Data Ready(i)

/* DAC */
#define DAC_SYNCN		PINC1	// chip select(o)

/* LED */
#define LED				PINB2	// LED(o)

//----------------------------------------------------------------
// AVRJE^`
//----------------------------------------------------------------

/* OSC; 0xFFFF - (18.432M / 256) => 65536 - 72000(0x11940) (13.88u x 72  1kHz(1mSec)) */
#define PI_TCNT1 0xFFB8			//1mSec

///* OSC; 0xFFFF - (12.288M / 256) => 65536 - 48000(0xBB80) (20.83u x 48  1kHz(1mSec)) */
//#define PI_TCNT1 0xFFD0			//1mSec

#define SUBTIME_DIV 1000		// 1/SUBTIME_DIV = 1mSec

//----------------------------------------------------------------
// 萔`
//----------------------------------------------------------------

#define NG				0
#define OK				1
#define	BINARY			2
#define	DECIMAL			10
#define	HEX				16

#define END_Mode		0
#define CV_Mode			1
#define CR_Mode			2
#define CP_Mode			3

#define Max_Current		5000			// mA\L
#define VI_Rs			20				// doRl(m)
#define VI_Gain			20				// I/VdQC (I x Rs x Gain = VDAC)
#define Imon_Gain		15				// dj^QC (I x Rs x Gain = Imon)
#define DAC_Vref		2500			// mV\L
//#define DAC_Vos			500				// mV\L
#define DAC_Vos			250				// mV\L

// UART
#define SCI_RX_SIZE 20
#define str2dec_buf_size 20				// SCI_RX_SIZE > str2dec_buf_size ɂȂƁB
										// ͂̎Ƀobt@ăn}邼B
// DAC
#define DAC_Res			65535
#define DA_DAC_Reset	0b00101000		// DAC_Reset
#define DA_DACA_Vout	0b00011000		// DAC_A
#define DA_DACB_Vout	0b00011001		// DAC_B
#define DA_DACAB_Vout	0b00011111		// DAC_A&B
#define DA_DAC_RefEN	0b00111000		// DAC_internalRef
#define DA_DAC_Gain		0b00000010		// DAC_Gain
#define DA_DAC_LDAC		0b00110000		// LDAC_Setting
#define DA_DACB_V		((DAC_Vos * DAC_Res) / DAC_Vref)	// CurrentSource LowerBias(500mV)
//#define DA_DACB_V		0x199A
//#define DA_DACB_V		0x0CCD

// ADC
// AD_MUX0(Adrs=00h)
#define AD_MUX0				0x00
#define AD_Vmon				0b00000001		// ADC1(dl,) AIN0= , AIN1=
#define AD_Imon				0b00010011		// ADC2(dl,) AIN2= , AIN3=
// AD_MUX1(Adrs=02h)
#define AD_MUX1				0x02
#define AD_MUX1_Data		0b00110000		// Ref_ON , RefI , ʏ퓮
// AD_SYS0(Adrs=03h)
#define	AD_SYS0				0x03
#define AD_SYS0_Data		0b00000101		// PGAQC1 , o̓f[^[g160SPS

#define AD_RDATA			0b00010010		// ADlǂݏo
#define AD_Vref				2048UL			// mVP
#define AD_FSR				32767UL			// 2^16 / 2 (oC|[̔)


// Lu[Vpf[^e[u
const unsigned int PROGMEM Cal_I[]				// 5mA,25mA,50mA,500mA,1500mA,3000mA,0
	= { 5, 25, 50, 500, 1500, 3000, 0 };

const unsigned int PROGMEM Cal_DA_I[]			// 5mA,25mA,50mA,500mA,1500mA,3000mA,0
	= { 0x19CE,0x1AA0,0x1BA6, 0x2E15, 0x570A, 0x947B, 0 };

//	const unsigned int PROGMEM Cal_DA_Vmon[]	// 0V,1.5V,3.0V,4.5V,0
//		= { 0x0000, 0x0579, 0x0AF2, 0x106B, 0 };
const unsigned int PROGMEM Cal_V[]				// 10mV,50mV,100mV,1.5V,3.0V,4.5V,0
	= { 10, 50, 100, 1500, 3000, 4500, 0 };


//----------------------------------------------------------------
// ֐vg^Cv錾
//----------------------------------------------------------------

void DEV_INIT(void);							// ӃfoCX
void delay_us(int time);
void delay_ms(int time);
void delay_sec(int time);
void sci_recvln(void);
int	SPI_byte_io(int tx_dat);
void DAC_DataOut(int DA_Command , int DA_Data);
void VI_Out(int Current);						// VI dwo
void CVRP_Drv(int Mode , int Param);			// d/R/d͈萧
void ADC_WriteReg(int AD_Adrs , int AD_Cmd);	// ADCpWX^
int ADC_Read(int AD_Ch);						// ADCf[^ǂݏo
void B_test(int Volt ,int Curr ,int m_time);	// obe
void P_test(int Curr ,int Volt ,int Curr_Step);	// dd
void V_Calib(void);								// dlLu[V
void I_Calib(void);								// dlLu[V
int V_Mon(void);								// ADCdf[^o(H)
int I_Mon(void);								// ADCdf[^o(H)
void eedump(void);								// EEPROM_v
void clreeprom(void);							// EEPROM
int str2dec(int start_byte);
void DEF_Check(void);
