/* -------------------------------------------------
	^C}1

	
		// OSC;10MHzp 0xFFFF - (10.0M / 1024) => 9765.625(0x2625) (102.4u x 9765  1Hz)
		#define PI_TCNT1 0xD9DA
		Int_intrp(PI_TCNT1);

------------------------------------------------ */

/* ^C}1̊荞ݏ */
void Int_intrp(unsigned int PI_TCNT1)
{
// **********************************************************
//   1.TCCR1B(Timer/Counter0 Control Register B)̐ݒ
//       ICNC1          : Input Capture1 Noise Cancel
//       ICES1          : Input Capture1 Edge Select
//       WGM13          : Waveform Generation Mode bit 3 and 2
//       WGM12          : Waveform Generation Mode bit 3 and 2
//       CS12,CS11,CS10 : Clock Select1, bit 2,1 and 0
//                           001; ` 101;1024
// **********************************************************
//    TCCR1B=(0<<ICNC1)|(0<<ICES1)|(0<<WGM13)|(0<<WGM12)|(1<<CS12)|(0<<CS11)|(1<<CS10) ;

//	TCCR1B = _BV(CS12)|_BV(CS10);	// 1/1024
	TCCR1B = _BV(CS12);				// 1/256

// **********************************************************
//   2.TIMSK(Timer/Counter Interrupt Mask Register)̐ݒ 
//        TOIE1   : Timer/Counter1 Overflow Interrupt Enable
//        OCIE1A  : Timer/Counter1 Output Compare A Match Interrupt Enable
//        OCIE1B  : Timer/Counter1 Output Compare B Match Interrupt Enable
//        ICIE1   : Timer/Counter1 Input Capture Interrupt Enabe
// ********************************************************** 
    TIMSK1=(1<<TOIE1)|(0<<OCIE1A)|(0<<OCIE1B)|(0<<ICIE1);

// **********************************************************
//   3.TCNT1(Timer/Counter 0)̐ݒ
// ********************************************************** 
    TCNT1=PI_TCNT1; 
}
